<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <v-app id="app">
    <!-- Splash Screen -->
    <splash-screen />

    <!-- Agreement dialog -->
    <client-only>
      <agreement-dialog v-if="enableAgreementsDialog" />
    </client-only>

    <client-only>
      <cookie-consent />
    </client-only>

    <!-- Navbar -->
    <nav-bar :sidebar.sync="sidebar" />

    <!-- Sidebar -->
    <side-bar :sidebar.sync="sidebar" />

    <!-- Content -->
    <v-main>
      <!-- Add feedback banner during testing phase -->
      <feedback-banner v-if="$auth.loggedIn" />
      <!-- Landing Page -->
      <template v-if="$route.name === 'landing'">
        <nuxt />
      </template>

      <!-- Containered Page -->
      <template v-else>
        <v-container>
          <nuxt />
        </v-container>
      </template>
    </v-main>

    <!-- Footer -->
    <foot-bar />
  </v-app>
</template>

<script lang="ts">
import { useContext, useRoute } from '@nuxtjs/composition-api'
import { computed, defineComponent, ref } from '@vue/composition-api'

export default defineComponent({
  setup() {
    const context = useContext()
    const route = useRoute()

    // If the sidebar is open or not.
    const sidebar = ref(false)

    // If the agreements dialog should be enabled
    // Only show the dialog when the user logged in
    // or when the user is not on the privacy agreement itself
    const enableAgreementsDialog = computed(
      () => context.$auth.loggedIn && !route.value.path.startsWith('/agreements')
    )

    return {
      sidebar,
      enableAgreementsDialog,
    }
  },
})
</script>

<style lang="scss">
// Import global styling
@import '~/assets/scss/global';
</style>
